-- Database schema for Eikon backend

create table imagemetadata (
	resource_id	char(20),
	width		int,
	height		int,
	image_type	varchar(20),	  -- contains the MIME type
	title		varchar(1000),
	description	text,		  -- a longer textual description
	date		date,		  -- only has day resolution
	place		varchar(1000),	  -- equals DC "coverage"
	rights		text,		  -- copyright statement or URL
	yavg		double precision, 
	iavg		double precision,
	qavg		double precision,
	constraint imagemetadata_pk primary key(resource_id)
);

create table searcharray (
	resource_id	char(20), -- I can use a foriegn key, I think
	x_position	int,
	y_position	int,
	value		smallint check (value in (-1, 1)),
	color		char(1) check (color in ('y', 'i', 'q')),
	constraint seacharray_fk foreign key (resource_id) 
		references imagemetadata (resource_id) on delete cascade
);

create table averages (
	resource_id	char(20),
	color		char(1),
	value		double precision,
	constraint averages_fk foreign key (resource_id)
		references imagemetadata (resource_id) on delete cascade
}
	
create table locations (
	resource_id	char(20),
	identifier	varchar(1000), -- url
	constraint locations_fk foreign key (resource_id)
		references imagemetadata (resource_id) on delete cascade
);
