/*
  Eikon is an image similarity search engine based on wavelets.
  Copyright (C) 2002 Luke Francl

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package org.francl.eikon.database;

import org.francl.eikon.util.Configuration;
import java.io.IOException;

/** Factory for return and selects the appropriate database **/
public class DatabaseFactory {
    public static final String DEFAULT_DB = "SerializedDatabase";
    
    public static Database getDatabase() {
	Configuration config;
	String db = null;
	try {
	    config = Configuration.getInstance();
	    db = config.get("database");
	} catch (IOException e) {
	    e.printStackTrace();
	    db = DEFAULT_DB;
	}

	if (db.equals("SerializedDatabase")) {
	    return SerializedDatabase.getInstance();
	    // TODO: Finish this implementation 
	    //	} else if (db.equals("PostgresDatabase")) {
	    //	    return PostgresDatabase.getInstance();
	} else {
	    String m = "No Database Implementation found for " + db + "." +
		"Perhaps your configuration file is incorrect. Otherwise " +
		"Something is seriously, seriously wrong.";
	    throw new DatabaseImplNotFoundException(m);
	}
    }
}

    
