/*
  Eikon is an image similarity search engine based on wavelets.
  Copyright (C) 2002 Luke Francl

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package org.francl.eikon.image;

import java.awt.image.BufferedImage;
import org.francl.eikon.wavelet.Signature;
import org.francl.eikon.wavelet.ColorChannelNotSupportedException;

public abstract class Image {

    public static final int MIN_IMAGE_WIDTH     = 128;
    public static final int MIN_IMAGE_HEIGHT    = 128;
    public static final int SCALED_IMAGE_WIDTH  = 128;
    public static final int SCALED_IMAGE_HEIGHT = 128;
    
    public abstract void setElements(char color, double[][] elements)
	throws ColorChannelNotSupportedException;
    public abstract double[][] getElements(char color)
	throws ColorChannelNotSupportedException;
    public abstract void setAverage(char color, double value)
	throws ColorChannelNotSupportedException;
    public abstract double getAverage(char color)
	throws ColorChannelNotSupportedException;
    public abstract int getHeight();
    public abstract int getWidth();
    public abstract String getColorSpace();
    public abstract Signature getSignature();
}
