/*
  Eikon is an image similarity search engine based on wavelets.
  Copyright (C) 2002 Luke Francl

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package org.francl.eikon.query;

import org.francl.eikon.util.ResourceId;

/** Holds an image's ResourceId and current score for a query. This class is
    my work around for not being able to easily sort HashMaps by value.
    The programmer can retrieve a collection of these from a HashMap and
    easily sort them. 
    
    @author Luke Francl
**/

public class Score implements Comparable {
    double score;
    ResourceId id;

    Score(ResourceId rid, double s) {
	this.id = rid;
	this.score = s;
    }

    public void setScore(double s) {
	this.score = s;
    }
    
    public double getScore() {
	return this.score;
    }

    public ResourceId getResourceId() {
	return this.id;
    }
    
    public String toString() {
	String s = "Score=" + score + " ResourceId=" + id.toString();
	return s;
    }

    public int compareTo(Object o) {
	double oscore = ((Score)o).score;
	if(this.score > oscore) {
	    return 1;
	} else if(this.score < oscore) {
	    return -1; 
	} else {
	    return 0;
	}
    }
}
