/*
  Eikon is an image similarity search engine based on wavelets.
  Copyright (C) 2002 Luke Francl

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package org.francl.eikon.util;

import java.util.Properties;
import java.io.InputStream;
import java.io.IOException;
import java.io.File;

/** This class abstracts reading from a properties file.
The Configuration class loads the properties file for you
from a pre-defined location (config/eikon.conf).
TODO: rugidize against NullPointerExceptions by having it return
sensible defaults...is returning empty string realistic for non-existent
properties?
@author Luke Francl
**/

public class Configuration {
    private static Configuration singleton = null;
    private Properties props;

    private Configuration() throws IOException {
	// changed to (hopefully) load properties file from Jar
	String pfile = "properties" + File.separator +"eikon.properties";
	InputStream in = getClass().getResourceAsStream("/" + pfile);
	props = new Properties();
	props.load(in);
    }

    public static Configuration getInstance() throws IOException {
	if (singleton == null) {
	    return new Configuration();
	} else {
	    return singleton;
	}
    }

    public String get(String key) {
	return props.getProperty(key);
    }
}
